<?php
/**
 * MyBB 1.4
 * Copyright © 2009 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybboard.net
  * License: http://www.mybboard.net/about/license
 *
 * $Id$
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

class IPB2_Converter_Module_Forumperms extends Converter_Module_Forumperms {

	var $settings = array(
		'friendly_name' => 'uprawnienia do działów',
		'progress_column' => 'id',
	);
	
	function import()
	{
		global $mybb, $output, $import_session, $db;

		$this->board->db_connect();

		// Get number of threads
		if(!isset($import_session['total_forumperms']))
		{
			$query = $this->old_db->simple_select("forums", "COUNT(*) as count");
			$import_session['total_forumperms'] = $this->old_db->fetch_field($query, 'count');
			$this->old_db->free_result($query);
		}

		if($this->board->check_if_done())
		{
			return "finished";
		}
		
		$output->print_header($this->board->modules[$import_session['module']]['name']);

		// Get number of threads per screen from form
		if(isset($mybb->input['forumperms_per_screen']))
		{
			$import_session['forumperms_per_screen'] = intval($mybb->input['forumperms_per_screen']);
		}
		
		if(empty($import_session['forumperms_groups']))
		{
			$query = $this->old_db->query("
				SELECT p.perm_id, g.g_perm_id, g.g_id 
				FROM ".OLD_TABLE_PREFIX."forum_perms p
				LEFT JOIN ".OLD_TABLE_PREFIX."groups g ON (p.perm_id=g.g_perm_id)
			");			
			while($permgroup = $this->old_db->fetch_array($query))
			{
				$import_session['forumperms_groups'][$permgroup['g_perm_id']] = $permgroup;
			}
			$this->old_db->free_result($query);
			$import_session['forumperms_groups_count'] = count($import_session['forumperms_groups']);
		}
		
		if(empty($import_session['forumperms_per_screen']))
		{
			$output->print_per_screen_page(1000);
		}
		else
		{
			// A bit of stats to show the progress of the current import
			$output->calculate_stats();
			
			$query = $this->old_db->simple_select("forums", "permission_array,id", "", array('limit_start' => $import_session['start_forumperms'], 'limit' => $import_session['forumperms_per_screen']));
			while($perm = $this->old_db->fetch_array($query))
			{
				$this->process_permission($perm);
			}
			
			if($this->old_db->num_rows($query) == 0)
			{
				$output->print_none_left_message();
			}
		}
		$import_session['start_forumperms'] += $import_session['forumperms_per_screen'];
		$output->print_footer();
	}
	
	function process_permission($data)
	{		
		$permission_array = unserialize(stripslashes($data['permission_array']));
				
		foreach($permission_array as $key => $permission)
		{
			// All permissions are on (global)
			if($permission == '*')
			{
				continue;
			}
			else
			{						
				$perm_split = explode(',', $permission);						
				foreach($perm_split as $key2 => $gid)
				{
					$new_perms[$this->board->get_group_id($gid, array("not_multiple" => true))][$key] = 1;
				}
			}
		}
		
		if(!empty($new_perms))
		{
			foreach($new_perms as $gid => $perm2)
			{
				foreach($permission_array as $key => $value)
				{
					if(!array_key_exists($key, $perm2))
					{
						$perm2[$key] = 0;
					}
				}
				$perm_array = $perm2;
				$perm_array['gid'] = $gid;

				$this->insert($perm_array);
			}
		}
	}
	
	function convert_data($data)
	{
		$insert_data = array();
				
		// Invision Power Board 2 values
		$insert_data['fid'] = $this->get_import->fid($data['id']);
		$insert_data['gid'] = $data['gid'];
		$insert_data['canpostthreads'] = yesno_to_int($data['start_perms']);
		$insert_data['canpostreplys'] = yesno_to_int($data['reply_perms']);
		$insert_data['candlattachments'] = yesno_to_int($data['download_perms']);
		$insert_data['canpostattachments'] = yesno_to_int($data['upload_perms']);
		$insert_data['canviewthreads'] = yesno_to_int($data['read_perms']);
		$insert_data['canview'] = yesno_to_int($data['show_perms']);
		
		return $insert_data;
	}
}

?>