<?php
/**
 * MyBB 1.4
 * Copyright © 2009 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybboard.net
  * License: http://www.mybboard.net/about/license
 *
 * $Id$
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

class IPB2_Converter_Module_Moderators extends Converter_Module_Moderators {

	var $settings = array(
		'friendly_name' => 'moderatorów',
		'progress_column' => 'moderator_id',
	);

	function import()
	{
		global $mybb, $output, $import_session, $db;

		$this->board->db_connect();

		// Get number of moderators
		if(!isset($import_session['total_moderators']))
		{
			$query = $this->old_db->simple_select("moderators", "COUNT(*) as count");
			$import_session['total_moderators'] = $this->old_db->fetch_field($query, 'count');
			$this->old_db->free_result($query);
		}

		if($this->board->check_if_done())
		{
			return "finished";
		}

		$output->print_header($this->board->modules[$import_session['module']]['name']);

		// Get number of posts per screen from form
		if(isset($mybb->input['moderators_per_screen']))
		{
			$import_session['moderators_per_screen'] = intval($mybb->input['moderators_per_screen']);
		}
		
		if(empty($import_session['moderators_per_screen']))
		{
			$output->print_per_screen_page(1000);
		}
		else
		{
			// A bit of stats to show the progress of the current import
			$output->calculate_stats();
			
			$query = $this->old_db->query("
            	SELECT mr.*, IF(mr.is_group = 1, m.id, mr.member_id) as member_id 
                FROM ".OLD_TABLE_PREFIX."moderators mr
                LEFT JOIN ".OLD_TABLE_PREFIX."members m ON(mr.group_id = m.mgroup) 
                LIMIT {$import_session['start_moderators']}, {$import_session['moderators_per_screen']}
            ");
			while($moderator = $this->old_db->fetch_array($query))
			{
				// Can't be empty or a group
                if($moderator['member_id'] == -1 || $moderator['member_id'] == "")
				{
                    continue;
                }
				
				$check_query = $db->simple_select("moderators", "COUNT(mid) as count", "uid='".$this->get_import->uid($moderator['member_id'])."' AND fid='".$this->get_import->fid($moderator['forum_id'])."'"); 
                if($db->fetch_field($check_query, 'count'))
				{
					$db->free_result($check_query);
                    continue;
                }
				
				$this->insert($moderator);			
			}
			
			if($this->old_db->num_rows($query) == 0)
			{
				$output->print_none_left_message();
			}
		}
		$import_session['start_moderators'] += $import_session['moderators_per_screen'];
		$output->print_footer();
	}
	
	function convert_data($data)
	{
		$insert_data = array();
				
		// Invision Power Board 2 values
		$insert_data['fid'] = $this->get_import->fid($data['forum_id']);
		$insert_data['uid'] = $this->get_import->uid($data['member_id']);
		$insert_data['caneditposts'] = $data['edit_post'];
		$insert_data['candeleteposts'] = $data['delete_post'];
		$insert_data['canviewips'] = $data['view_ip'];
		$insert_data['canopenclosethreads'] = $data['close_topic'];
		$insert_data['canmovetononmodforum'] = $data['move_topic'];
		
		return $insert_data;
	}
}

?>