<?php
/**
 * MyBB 1.4
 * Copyright ę 2009 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybboard.net
  * License: http://www.mybboard.net/about/license
 *
 * $Id$
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

class IPB2_Converter_Module_Polls extends Converter_Module_Polls {

	var $settings = array(
		'friendly_name' => 'ankiet',
		'progress_column' => 'pid',
	);

	function import()
	{
		global $mybb, $output, $import_session, $db;

		$this->board->db_connect();

		// Get number of threads
		if(!isset($import_session['total_polls']))
		{
			$query = $this->old_db->simple_select("polls", "COUNT(*) as count");
			$import_session['total_polls'] = $this->old_db->fetch_field($query, 'count');
			$this->old_db->free_result($query);
		}

		if($this->board->check_if_done())
		{
			return "finished";
		}
		
		$output->print_header($this->board->modules[$import_session['module']]['name']);

		// Get number of polls per screen from form
		if(isset($mybb->input['polls_per_screen']))
		{
			$import_session['polls_per_screen'] = intval($mybb->input['polls_per_screen']);
		}
		
		if(empty($import_session['polls_per_screen']))
		{
			$output->print_per_screen_page(1000);
		}
		else
		{
			// A bit of stats to show the progress of the current import
			$output->calculate_stats();

			$query = $this->old_db->simple_select("polls", "*", "", array('limit_start' => $import_session['start_polls'], 'limit' => $import_session['polls_per_screen']));
			while($poll = $this->old_db->fetch_array($query))
			{
				$pid = $this->insert($poll);
				
				// Restore connections
				$db->update_query("threads", array('poll' => $pid), "import_tid = '".$poll['tid']."'");		
			}
			
			if($this->old_db->num_rows($query) == 0)
			{
				$output->print_none_left_message();
			}
		}
		$import_session['start_polls'] += $import_session['polls_per_screen'];
		$output->print_footer();
	}
	
	function convert_data($data)
	{
		global $db;
		
		$insert_data = array();
		
		$insert_data['import_tid'] = $data['tid'];
		$insert_data['tid'] = $this->get_import->tid($data['tid']);
		$choices = unserialize($data['choices']);
		$choices = $choices[1];

		$seperator = '';
		$choices1 = '';
		$choice_count = 0;
		foreach($choices['choice'] as $key => $choice)
		{
			++$choice_count;
			$choices1 .= $seperator.$db->escape_string($choice);
			$seperator = '||~|~||';
		}
		
		$seperator = '';
		$votes = '';
		foreach($choices['votes'] as $key => $vote)
		{
			$votes .= $seperator.$vote;
			$seperator = '||~|~||';
		}
		
		$insert_data['question'] = $choices['question'];
		$insert_data['dateline'] = $data['start_date'];
		$insert_data['options'] = $choices1;
		$insert_data['votes'] = $votes;
		$insert_data['numoptions'] = $choice_count;
		$insert_data['numvotes'] = $data['votes'];
		$insert_data['multiple'] = $choices['multi'];
		
		return $insert_data;
	}
}

?>