<?php
/**
 * MyBB 1.4
 * Copyright © 2009 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybboard.net
  * License: http://www.mybboard.net/about/license
 *
 * $Id$
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

class IPB2_Converter_Module_Privatemessages extends Converter_Module_Privatemessages {

	var $settings = array(
		'friendly_name' => 'prywatnych wiadomości',
		'progress_column' => 'msg_id',
	);

	function import()
	{
		global $mybb, $output, $import_session, $db;

		$this->board->db_connect();

		// Get number of usergroups
		if(!isset($import_session['total_privatemessages']))
		{
			$query = $this->old_db->simple_select("message_text", "COUNT(*) as count");
			$import_session['total_privatemessages'] = $this->old_db->fetch_field($query, 'count');
			$this->old_db->free_result($query);
		}

		if($this->board->check_if_done())
		{
			return "finished";
		}

		$output->print_header($this->board->modules[$import_session['module']]['name']);

		// Get number of posts per screen from form
		if(isset($mybb->input['privatemessages_per_screen']))
		{
			$import_session['privatemessages_per_screen'] = intval($mybb->input['privatemessages_per_screen']);
		}
		
		if(empty($import_session['privatemessages_per_screen']))
		{
			$output->print_per_screen_page(1000);
		}
		else
		{			
			// A bit of stats to show the progress of the current import
			$output->calculate_stats();
			
			$query = $this->old_db->query("
				SELECT * 
				FROM ".OLD_TABLE_PREFIX."message_text m
				LEFT JOIN ".OLD_TABLE_PREFIX."message_topics mt ON(m.msg_id=mt.mt_msg_id)
				LIMIT ".$import_session['start_privatemessages'].", ".$import_session['privatemessages_per_screen']
			);			
			while($pm = $this->old_db->fetch_array($query))
			{
				$this->insert($pm);
			}
			
			if($this->old_db->num_rows($query) == 0)
			{
				$output->print_none_left_message();
			}
		}
		$import_session['start_privatemessages'] += $import_session['privatemessages_per_screen'];
		$output->print_footer();
	}
	
	function convert_data($data)
	{		
		$insert_data = array();
				
		// Invision Power Board 2 values
		$insert_data['import_pmid'] = $data['msg_id'];
		$insert_data['uid'] = $this->get_import->uid($data['msg_author_id']);
		$insert_data['fromid'] = $this->get_import->uid($data['mt_from_id']);
		$insert_data['toid'] = $this->get_import->uid($data['mt_to_id']);
		$touserarray = explode('<br />', $data['msg_cc_users']);

		// Rebuild the recipients array
		$recipients = array();
		foreach($touserarray as $key => $to)
		{
			$username = $this->get_username($to);				
			$recipients['to'][] = $this->get_import->username($username['id']);
		}
		$insert_data['recipients'] = serialize($recipients);
		
		if($data['mt_vid_folder'] == 'sent')
		{
			$insert_data['folder'] = 2;
		}
		elseif($data['mt_vid_folder'] == 'unsent')
		{
			$insert_data['folder'] = 3;
		}
		else
		{
			$insert_data['folder'] = 1;
		}
		
		$insert_data['subject'] = encode_to_utf8($data['mt_title'], "message_text", "privatemessages");
		$insert_data['status'] = $data['mt_read'];
		$insert_data['dateline'] = $data['mt_date'];
		$insert_data['message'] = encode_to_utf8($this->bbcode_parser->convert($data['msg_post']), "message_text", "privatemessages");
		$insert_data['readtime'] = $data['mt_user_read'];
		
		return $insert_data;
	}
	
	/**
	 * Get a user from the IPB database
	 *
	 * @param int Username
	 * @return array If the username is empty, returns an array of username as Guest.  Otherwise returns the user
	 */
	function get_username($username)
	{
		if($username == '')
		{
			return array(
				'username' => 'Gość',
				'id' => 0,
			);
		}
		
		$query = $this->old_db->simple_select("members", "*", "name='{$username}'", array('limit' => 1));
		
		$results = $this->old_db->fetch_array($query);
		$this->old_db->free_result($query);
		
		return $results;
	}
}

?>