<?php
/**
 * MyBB 1.4
 * Copyright ę 2009 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybboard.net
  * License: http://www.mybboard.net/about/license
 *
 * $Id$
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

class IPB2_Converter_Module_Settings extends Converter_Module_Settings {

	var $settings = array(
		'friendly_name' => 'ustawień',
	);

	function import()
	{
		global $mybb, $output, $import_session, $db;

		$this->board->db_connect();
		
		// What settings do we need to get and what is their MyBB equivalent?
		$settings_array = array(
			"board_offline" => "boardclosed",
			"offline_msg" => "boardclosed_reason",
			"au_cutoff" => "wolcutoffmins",
			"how_totals" => "showindexstats",
			"show_active" => "showwol",
			"load_limit" => "load",
			"disable_subforum_show" => "subforumsindex",
			"mail_method" => "mail_handler",
			"smtp_host" => "smtp_host",
			"smtp_port" => "smtp_port",
			"smtp_user" => "smtp_user",
			"smtp_pass" => "smtp_pass",
			"php_mail_extra" => "mail_parameters",
			"csite_pm_show" => "portal_showwelcome",
			"csite_search_show" => "portal_showsearch",
			"msg_allow_code" => "pmsallowmycode",
			"msg_allow_html" => "pmsallowhtml",
			"search_sql_method" => "searchtype",
			"min_search_word" => "minsearchword",
			"display_max_topics" => "threadsperpage",
			"hot_topic" => "hottopic",
			"display_max_posts" => "postsperpage",
			"max_images" => "maxpostimages",
			"siu_thumb" => "attachthumbnails",
			"siu_width" => "attachthumbw",
			"siu_height" => "attachthumbh",
			"max_poll_choices" => "maxpolloptions",
			"post_wordwrap" => "wordwrap",
			"max_sig_length" => "siglength",
			"sig_allow_html" => "sightml",
			"sig_allow_ibc" => "sigmycode",
			"postpage_contents" => "userpppoptions",
			"topicpage_contents" => "usertppoptions",
			"avup_size_max" => "avatarsize",
			"avatar_dims" => "maxavatardims",
			"ipb_bruteforce_attempts" => "failedlogincount",
			"ipb_bruteforce_period" => "failedlogintime",
			"no_reg" => "disableregs",
			"flood_control" => "postfloodsecs",
			"ipb_display_version" => "showvernum",			
		);
		$settings = "'".implode("','", array_keys($settings_array))."'";

		// Get number of settings
		if(!isset($import_session['total_settings']))
		{
			$query = $this->old_db->simple_select("conf_settings", "COUNT(*) as count");
			$import_session['total_settings'] = $this->old_db->fetch_field($query, 'count');
			$this->old_db->free_result($query);
		}

		if($this->board->check_if_done())
		{
			rebuild_settings();
			return "finished";
		}

		$output->print_header($this->board->modules[$import_session['module']]['name']);

		// Get number of settings per screen from form
		if(isset($mybb->input['settings_per_screen']))
		{
			$import_session['settings_per_screen'] = intval($mybb->input['settings_per_screen']);
		}

		if(empty($import_session['settings_per_screen']))
		{
			$output->print_per_screen_page(1000);
		}
		else
		{
			// A bit of stats to show the progress of the current import
			$output->calculate_stats();

			$query = $this->old_db->simple_select("conf_settings", "conf_key, conf_value, conf_default", "", array('limit_start' => $import_session['start_settings'], 'limit' => $import_session['settings_per_screen']));
			while($setting = $this->old_db->fetch_array($query))
			{
				// Invision Power Board 2 values
				$name = $settings_array[$setting['conf_key']];
				
				if(empty($setting['conf_value']))
				{
					$value = $setting['conf_default'];
				}
				else
				{
					$value = $setting['conf_value'];
				}
				
				if($setting['conf_key'] == "disable_subforum_show")
				{
					if($value == "on")
					{
						$value = "1000";
					}
					else
					{
						$value = 0;
					}
				}
				
				if($setting['conf_key'] == "search_sql_method")
				{
					if($value == "ftext")
					{
						$value = "fulltext";
					}
					else
					{
						$value = "standard";
					}
				}
					
				$this->update_setting($name, $value);
			}
			
			if($this->old_db->num_rows($query) == 0)
			{
				$output->print_none_left_message();
			}
		}
		$import_session['start_settings'] += $import_session['settings_per_screen'];
		$output->print_footer();
	}
}

?>