<?php
/**
 * MyBB 1.4
 * Copyright © 2009 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybboard.net
  * License: http://www.mybboard.net/about/license
 *
 * $Id$
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

class IPB2_Converter_Module_Usergroups extends Converter_Module_Usergroups {

	var $settings = array(
		'friendly_name' => 'grup użytkowników',
		'progress_column' => 'g_id',
	);

	function import()
	{
		global $mybb, $output, $import_session, $db;

		$this->board->db_connect();

		// Get number of usergroups
		if(!isset($import_session['total_usergroups']))
		{
			$query = $this->old_db->simple_select("groups", "COUNT(*) as count", "g_id > 6");
			$import_session['total_usergroups'] = $this->old_db->fetch_field($query, 'count');
			$this->old_db->free_result($query);
		}

		if($this->board->check_if_done())
		{
			return "finished";
		}

		$output->print_header($this->board->modules[$import_session['module']]['name']);

		// Get number of posts per screen from form
		if(isset($mybb->input['usergroups_per_screen']))
		{
			$import_session['usergroups_per_screen'] = intval($mybb->input['usergroups_per_screen']);
		}
		
		if(empty($import_session['usergroups_per_screen']))
		{
			$output->print_per_screen_page(1000);
		}
		else
		{
			// A bit of stats to show the progress of the current import
			$output->calculate_stats();
			
			// Get only non-staff groups.
			$query = $this->old_db->simple_select("groups", "*", "g_id > 6", array('limit_start' => $import_session['start_usergroups'], 'limit' => $import_session['usergroups_per_screen']));
			while($group = $this->old_db->fetch_array($query))
			{
				$gid = $this->insert($group);
				
				// Restore connections
				$db->update_query("users", array('usergroup' => $gid), "import_usergroup = '{$group['g_id']}' OR import_displaygroup = '{$group['g_id']}'");	
			}
			
			if($this->old_db->num_rows($query) == 0)
			{
				$output->print_none_left_message();
			}
		}
		$import_session['start_usergroups'] += $import_session['usergroups_per_screen'];
		$output->print_footer();
	}
	
	function convert_data($data)
	{
		$insert_data = array();
				
		// Invision Power Board 2 values
		$insert_data['import_gid'] = $data['g_id'];				
		$insert_data['title'] = $data['g_title'];
		$insert_data['pmquota'] = $data['g_max_messages'];
		$insert_data['maxpmrecipients'] = $data['g_max_mass_pm'];
		$insert_data['attachquota'] = $data['g_attach_max'];
		$insert_data['caneditposts'] = $data['g_edit_posts'];
		$insert_data['candeleteposts'] = $data['g_delete_own_posts'];
		$insert_data['candeletethreads'] = $data['g_delete_own_topics'];
		$insert_data['canpostpolls'] = $data['g_post_polls'];
		$insert_data['canvotepolls'] = $data['g_vote_polls'];
		$insert_data['canusepms'] = $data['g_use_pm'];
		$insert_data['cancp'] = $data['g_access_cp'];
		$insert_data['issupermod'] = intval($data['g_is_supermod']);
		$insert_data['cansearch'] = $data['g_use_search'];
		$insert_data['canuploadavatars'] = $data['g_avatar_upload'];
		$insert_data['canview'] = $data['g_view_board'];
		$insert_data['canviewprofiles'] = $data['g_mem_info'];
		$insert_data['canpostthreads'] = $data['g_post_new_topics'];
		$insert_data['canpostreplys'] = $data['g_reply_other_topics'];
		
		return $insert_data;
	}
}

?>