<?php
/**
 * MyBB 1.4
 * Copyright ę 2009 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybboard.net
  * License: http://www.mybboard.net/about/license
 *
 * $Id$
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

class PHPBB2BYPRZEMO_Converter_Module_Categories extends Converter_Module_Categories {

	var $settings = array(
		'friendly_name' => 'kategorie',
		'progress_column' => 'cat_id',
	);

	function import()
	{
		global $mybb, $output, $import_session, $db;

		$this->board->db_connect();

		// Get number of categories
		if(!isset($import_session['total_categories']))
		{
			$query = $this->old_db->simple_select("categories", "COUNT(*) as count");
			$import_session['total_categories'] = $this->old_db->fetch_field($query, 'count');
			$this->old_db->free_result($query);				
		}

		if($this->board->check_if_done())
		{
			return "finished";
		}

		$output->print_header($this->board->modules[$import_session['module']]['name']);

		// Get number of categories per screen from form
		if(isset($mybb->input['categories_per_screen']))
		{
			$import_session['categories_per_screen'] = intval($mybb->input['categories_per_screen']);
		}
		
		if(empty($import_session['categories_per_screen']))
		{
			$output->print_per_screen_page(1000);
		}
		else
		{
			// A bit of stats to show the progress of the current import
			$output->calculate_stats();
			
			$query = $this->old_db->simple_select("categories", "*", "", array('limit_start' => $import_session['start_categories'], 'limit' => $import_session['categories_per_screen']));
			while($category = $this->old_db->fetch_array($query))
			{
				$fid = $this->insert($category);
				
				// Update parent list.
				$db->update_query("forums", array('parentlist' => $fid), "fid = '{$fid}'");
			}
			
			if($this->old_db->num_rows($query) == 0)
			{
				$output->print_none_left_message();
			}
		}			
		$import_session['start_categories'] += $import_session['categories_per_screen'];
		$output->print_footer();
	}
	
	function convert_data($data)
	{
		$insert_data = array();
		
		// Values from phpBB
		$insert_data['import_fid'] = intval($data['cat_id']);
		$insert_data['name'] = encode_to_utf8($data['cat_title'], "categories", "forums");
		$insert_data['disporder'] = $data['cat_order'];
		$insert_data['type'] = "c";

		return $insert_data;
	}
}

?>