<?php
/**
 * MyBB 1.4
 * Copyright © 2009 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybboard.net
  * License: http://www.mybboard.net/about/license
 *
 * $Id$
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

class PHPBB2BYPRZEMO_Converter_Module_Forumperms extends Converter_Module_Forumperms {

	var $settings = array(
		'friendly_name' => 'uprawnienia do działów',
		'progress_column' => 'fid',
	);
	
	var $convert_val = array(
			'caneditposts' => 'auth_edit',
			'candeleteposts' => 'auth_delete',
			'caneditattachments' => 'auth_attachments',
			'canpostpolls' => 'auth_pollcreate',
			'canvotepolls' => 'auth_vote',
			'canpostthreads' => 'auth_post',
			'canpostreplys' => 'auth_reply',
			'candlattachments' => 'auth_attachments',
			'canpostattachments' => 'auth_attachments',
			'canviewthreads' => 'auth_view',
			'canview' => 'auth_view'
		);

	function import()
	{
		global $mybb, $output, $import_session, $db;

		$this->board->db_connect();

		// Get number of threads
		if(!isset($import_session['total_forumperms']))
		{
			$query = $this->old_db->simple_select("forums", "COUNT(*) as count");
			$import_session['total_forumperms'] = $this->old_db->fetch_field($query, 'count');				
		}

		if($this->board->check_if_done())
		{
			return "finished";
		}
		
		$output->print_header($this->board->modules[$import_session['module']]['name']);

		// Get number of threads per screen from form
		if(isset($mybb->input['forumperms_per_screen']))
		{
			$import_session['forumperms_per_screen'] = intval($mybb->input['forumperms_per_screen']);
		}
		
		if(empty($import_session['forumperms_per_screen']))
		{
			$output->print_per_screen_page(1000);
		}
		else
		{
			// A bit of stats to show the progress of the current import
			$output->calculate_stats();
			
			$query = $this->old_db->simple_select("forums", "forum_id,auth_view,auth_read,auth_post,auth_reply,auth_edit,auth_delete,auth_sticky,auth_announce,auth_vote,auth_pollcreate,auth_attachments", "", array('limit_start' => $import_session['start_forumperms'], 'limit' => $import_session['forumperms_per_screen']));
			while($perm = $this->old_db->fetch_array($query))
			{
				$this->process_permission_matrix($perm);
			}		
			
			$this->process_permissions();
			
			if($this->old_db->num_rows($query) == 0)
			{
				$output->print_none_left_message();
			}
		}
		$import_session['start_forumperms'] += $import_session['forumperms_per_screen'];
		$output->print_footer();
	}
	
	function process_permission_matrix($perm)
	{
		foreach($perm as $column => $value)
		{
			if($column == "forum_id")
			{
				continue;
			}
			
			switch($value)
			{
				case 0:
					$this->permissions[$perm['forum_id']][1][$column] = 1;
					$this->permissions[$perm['forum_id']][2][$column] = 1;
					$this->permissions[$perm['forum_id']][3][$column] = 1;
					$this->permissions[$perm['forum_id']][4][$column] = 1;
					break;
				case 1:
					$this->permissions[$perm['forum_id']][2][$column] = 1;
					$this->permissions[$perm['forum_id']][4][$column] = 1;
					$this->permissions[$perm['forum_id']][3][$column] = 1;
					break;
				case 2:
				case 3:
					$this->permissions[$perm['forum_id']][4][$column] = 1;
					break;
				case 4:
					$this->permissions[$perm['forum_id']][3][$column] = 1;
					$this->permissions[$perm['forum_id']][4][$column] = 1;
					break;
				default:
					continue;
			}
		}
	}
	
	function process_permissions()
	{
		if(is_array($this->permissions))
		{
			foreach($this->permissions as $fid => $groups)
			{
				foreach($groups as $gid => $columns)
				{
					$perm = array(
						'fid' => $fid,
						'gid' => $gid,
						'columns' => $columns,
					);
					
					$this->insert($perm);
				}
			}
		}
	}
	
	function convert_data($data)
	{
		$insert_data = array();
		
		// phpBB 2 values
		$insert_data['fid'] = $this->get_import->fid_f($data['fid']);
		$insert_data['gid'] = $this->board->get_group_id($data['gid'], array("not_multiple" => true));
		
		foreach($this->convert_val as $mybb_column => $phpbb_column)
		{
			if(!$data['columns'][$phpbb_column])
			{
				$data['columns'][$phpbb_column] = 0;
			}
			
			$insert_data[$mybb_column] = $data['columns'][$phpbb_column];					
		}
		
		return $insert_data;
	}
}

?>