<?php
/**
 * MyBB 1.4
 * Copyright © 2009 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybboard.net
  * License: http://www.mybboard.net/about/license
 *
 * $Id$
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

class PUNBB_Converter_Module_Threads extends Converter_Module_Threads {

	var $settings = array(
		'friendly_name' => 'wątków',
		'progress_column' => 'id',
	);

	function import()
	{
		global $mybb, $output, $import_session, $db;

		$this->board->db_connect();

		// Get number of threads
		if(!isset($import_session['total_threads']))
		{
			$query = $this->old_db->simple_select("topics", "COUNT(*) as count");
			$import_session['total_threads'] = $this->old_db->fetch_field($query, 'count');
			$this->old_db->free_result($query);
		}

		if($this->board->check_if_done())
		{
			return "finished";
		}
		
		$output->print_header($this->board->modules[$import_session['module']]['name']);

		// Get number of threads per screen from form
		if(isset($mybb->input['threads_per_screen']))
		{
			$import_session['threads_per_screen'] = intval($mybb->input['threads_per_screen']);
		}
		
		if(empty($import_session['threads_per_screen']))
		{
			$output->print_per_screen_page(1000);
		}
		else
		{
			// A bit of stats to show the progress of the current import
			$output->calculate_stats();

			$query = $this->old_db->simple_select("topics", "*", "", array('limit_start' => $import_session['start_threads'], 'limit' => $import_session['threads_per_screen']));
			while($thread = $this->old_db->fetch_array($query))
			{
				$this->insert($thread);		
			}
			
			if($this->old_db->num_rows($query) == 0)
			{
				$output->print_none_left_message();
			}
		}
		$import_session['start_threads'] += $import_session['threads_per_screen'];
		$output->print_footer();
	}
	
	function convert_data($data)
	{
		$insert_data = array();
		
		// punBB values
		$insert_data['import_tid'] = $data['id'];
		$insert_data['sticky'] = $data['sticky'];
		$insert_data['fid'] = $this->get_import->fid_f($data['forum_id']);
		$insert_data['firstpost'] = ((-1) * $this->get_first_post($data['id']));
		$insert_data['dateline'] = $data['posted'];
		$insert_data['subject'] = encode_to_utf8($data['subject'], "topics", "threads");
		
		$user = $this->board->get_user($data['poster']);
		
		$insert_data['uid'] = $this->get_import->uid($user['id']);
		$insert_data['import_uid'] = $user['id'];
		$insert_data['views'] = $data['num_views'];
		$insert_data['closed'] = $data['closed'];
		if($insert_data['closed'] == "no")
		{
			$insert_data['closed'] = '';
		}
		
		return $insert_data;
	}
	
	/**
	 * Gets the pid of the first post of a thread from the punBB database
	 *
	 * @param int Thread ID
	 * @return integer first post id
	 */
	function get_first_post($tid)
	{
		$query = $this->old_db->simple_select("posts", "*", "topic_id = '{$tid}'", array('order_by' => 'posted', 'order_dir' => 'ASC', 'limit' => 1));
		return $this->old_db->fetch_field($query, "id");
	}
}

?>