<?php
/**
 * MyBB 1.4
 * Copyright ę 2009 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybboard.net
  * License: http://www.mybboard.net/about/license
 *
 * $Id$
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

class BBCode_Parser {

	function convert($message)
	{
		$message = str_replace(array('[center]', '[/center]', '<br />'), array('[align=center]', '[/align]', "\n"), $message);
		$message = preg_replace("#\[size=([0-9\+\-]+?)pt\](.*?)\[/size\]#si", "[size=$1]$2[/size]", $message);
		$message = preg_replace("#\[li\](.*?)\[/li\]#si", "[*]$1", $message);
		$message = preg_replace("#\[quote(.*?)\](.*?)\[\/quote\]#esi", "\$this->mycode_parse_post_quotes('$2', '$1')", $message);
		return $message;
	}
	
	/**
	* Parses SMF quotes with author, post id and/or dateline.
	*
	* @param string The message to be parsed
	* @param string The information to be parsed
	* @return string The parsed message.
	*/
	function mycode_parse_post_quotes($message, $info)
	{
		$info = trim($info);
		
		preg_match("#author=(.*?)=#i", $info, $match);
		if($match[1])
		{
			$username = $match[1];
		}
		
		/*preg_match("#link=topic=([0-9]+).msg?([0-9]+)\#msg([0-9]+)?#i", $info, $match);
		if($match[1])
		{
			$pid = $match[1];
		}*/
		
		preg_match("#date=?([0-9]+)#i", $info, $match);
		if($match[1])
		{
			$dateline = $match[1];
		}

		return "[quote='{$username}' dateline='{$dateline}']{$message}[/quote]";
	}
}
?>