<?php
/**
 * MyBB 1.4
 * Copyright © 2009 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybboard.net
  * License: http://www.mybboard.net/about/license
 *
 * $Id$
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

class SMF_Converter_Module_Pollvotes extends Converter_Module_Pollvotes {

	var $settings = array(
		'friendly_name' => 'głosów w ankietach',
		'progress_column' => 'ID_POLL',
	);

	function import()
	{
		global $mybb, $output, $import_session, $db;

		$this->board->db_connect();

		// Get number of threads
		if(!isset($import_session['total_pollvotes']))
		{
			$query = $this->old_db->simple_select("log_polls", "COUNT(*) as count");
			$import_session['total_pollvotes'] = $this->old_db->fetch_field($query, 'count');
			$this->old_db->free_result($query);
		}

		if($this->board->check_if_done())
		{
			return "finished";
		}
		
		$output->print_header($this->board->modules[$import_session['module']]['name']);

		// Get number of poll votes per screen from form
		if(isset($mybb->input['pollvotes_per_screen']))
		{
			$import_session['pollvotes_per_screen'] = intval($mybb->input['pollvotes_per_screen']);
		}
		
		if(empty($import_session['pollvotes_per_screen']))
		{
			$output->print_per_screen_page(1000);
		}
		else
		{
			// A bit of stats to show the progress of the current import
			$output->calculate_stats();
			
			$count = $import_session['start_pollvotes'];
			
			if($count == 0)
			{
				++$count;
			}
			
			$query = $this->old_db->simple_select("log_polls", "*", "", array('limit_start' => $import_session['start_pollvotes'], 'limit' => $import_session['pollvotes_per_screen']));
			while($pollvote = $this->old_db->fetch_array($query))
			{				
				$this->insert($pollvote);
				
				++$count;
			}
			
			if($this->old_db->num_rows($query) == 0)
			{
				$output->print_none_left_message();
			}
		}
		$import_session['start_pollvotes'] += $import_session['pollvotes_per_screen'];
		$output->print_footer();
	}
	
	function convert_data($data)
	{
		global $db;
		
		$insert_data = array();
		
		// SMF values
		$poll = $this->get_import->poll($data['ID_POLL']);
		
		$insert_data['uid'] = $this->get_import->uid($data['ID_MEMBER']);
		$insert_data['dateline'] = $poll['dateline'];
		$insert_data['voteoption'] = $data['ID_CHOICE'];
		$insert_data['pid'] = $poll['pid'];
		
		return $insert_data;
	}
	
	function test()
	{
		// import_pollid => pollid
		$this->get_import->cache_pollids = array(
			2 => 10
		);
		
		// import_pollid => poll
		$this->get_import->cache_polls = array(
			2 => array(
				'dateline' => 12345678,
				'pid' => 3,
			),
		);
		
		// import_uid => uid
		$this->get_import->cache_uids = array(
			4 => 11
		);
		
		$data = array(
			'ID_POLL' => 2,
			'ID_MEMBER' => 4,
			'ID_CHOICE' => 1,
		);
		
		$match_data = array(
			'uid' => 11,
			'dateline' => 12345678,
			'voteoption' => 1,
			'pid' => 3,			
		);
		
		$this->assert($data, $match_data);
	}
}

?>