<?php
/**
 * MyBB 1.4
 * Copyright ę 2009 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybboard.net
  * License: http://www.mybboard.net/about/license
 *
 * $Id$
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

class SMF_Converter_Module_Settings extends Converter_Module_Settings {

	var $settings = array(
		'friendly_name' => 'ustawień',
	);

	function import()
	{
		global $mybb, $output, $import_session, $db;

		$this->board->db_connect();
		
		// What settings do we need to get and what is their MyBB equivalent?
		$settings_array = array(
			"karmaMode" => "enablereputation",
			"enableCompressedOutput" => "gzipoutput",
			"attachmentNumPerPostLimit" => "maxattachments",
			"attachmentThumbnails" => "attachthumbnails",
			"attachmentThumbWidth" => "attachthumbw",
			"attachmentThumbHeight" => "attachthumbh",
			"enableErrorLogging" => "useerrorhandling",
			"cal_enabled" => "enablecalendar",
			"smtp_host" => "smtp_host",
			"smtp_port" => "smtp_port",
			"smtp_username" => "smtp_user",
			"smtp_password" => "smtp_pass",
			"mail_type" => "mail_handler",
			"hotTopicPosts" => "hottopic",
			"registration_method" => "regtype",
			"spamWaitTime" => "postfloodsecs",
			"reserveNames" => "bannedusernames",
			"avatar_max_height_upload" => "maxavatardims",
			"avatar_max_width_upload" => "maxavatardims",
			"failed_login_threshold" => "failedlogincount",
			"edit_disable_time" => "edittimelimit",
			"max_messageLength" => "maxmessagelength",
			"max_signatureLength" => "siglength",
			"defaultMaxTopics" => "threadsperpage",
			"defaultMaxMembers" => "membersperpage",
			"time_offset" => "timezoneoffset"
		);
		$settings = "'".implode("','", array_keys($settings_array))."'";
		$int_to_yes_no = array(
			"karmaMode" => 1,
			"enableCompressedOutput" => 1,
			"attachmentThumbnails" => 1,
			"cal_enabled" => 1
		);
		
		$int_to_on_off = array(
			"enableErrorLogging" => 1
		);
		
		// Get number of settings
		if(!isset($import_session['total_settings']))
		{
			$query = $this->old_db->simple_select("settings", "COUNT(*) as count", "variable IN({$settings})");
			$import_session['total_settings'] = $this->old_db->fetch_field($query, 'count');
			$this->old_db->free_result($query);
		}

		if($this->board->check_if_done())
		{
			rebuild_settings();
			return "finished";
		}
		
		$output->print_header($this->board->modules[$import_session['module']]['name']);

		// Get number of settings per screen from form
		if(isset($mybb->input['settings_per_screen']))
		{
			$import_session['settings_per_screen'] = intval($mybb->input['settings_per_screen']);
		}

		if(empty($import_session['settings_per_screen']))
		{
			$output->print_per_screen_page(1000);
		}
		else
		{
			// A bit of stats to show the progress of the current import
			$output->calculate_stats();

			$query = $this->old_db->simple_select("settings", "variable, value", "variable IN({$settings})", array('limit_start' => $import_session['start_settings'], 'limit' => $import_session['settings_per_screen']));
			while($setting = $this->old_db->fetch_array($query))
			{
				// SMF values
				$name = $settings_array[$setting['variable']];
				$value = $setting['value'];
				
				if($setting['variable'] == "karmaMode")
				{
					if($value == "2")
					{
						$value = 1;
					}
				}
				
				if($setting['variable'] == "mail_type")
				{
					if($value == 1)
					{
						$value = "smtp";
					}
					else
					{
						$value = "mail";
					}	
				}
				
				if($setting['variable'] == "avatar_max_height_upload")
				{
					$avatar_setting = "x".$value;
					continue;	
				}
				else if($setting['variable'] == "avatar_max_width_upload")
				{
					$value = $value.$avatar_setting;
					unset($avatar_setting);
				}
				
				if($setting['variable'] == "registration_method")
				{
					if($value == 0)
					{
						$value = "instant";
					}
					else if($value == 2)
					{
						$value = "admin";
					}
					else
					{
						$value = "verify";
					}
				}
				
				if($setting['variable'] == "reserveNames")
				{
					$value = str_replace("\n", ",", $value);
				}
						
				if(($value == 0 || $value == 1) && isset($int_to_yes_no[$setting['conf_name']]))
				{
					$value = int_to_yes_no($value, $int_to_yes_no[$setting['conf_name']]);
				}
				
				if(($value == 0 || $value == 1) && isset($int_to_on_off[$setting['variable']]))
				{
					$value = int_to_on_off($value, $int_to_on_off[$setting['variable']]);
				}
				
				$this->update_setting($name, $value);
			}
			if($this->old_db->num_rows($query) == 0)
			{
				$output->print_none_left_message();
			}
		}
		$import_session['start_settings'] += $import_session['settings_per_screen'];
		$output->print_footer();
	}
}

?>