<?php
/**
 * MyBB 1.4
 * Copyright © 2009 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybboard.net
  * License: http://www.mybboard.net/about/license
 *
 * $Id$
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

class VBULLETIN3_Converter_Module_Forumperms extends Converter_Module_Forumperms {

	var $settings = array(
		'friendly_name' => 'uprawnienia do działów',
		'progress_column' => 'forumid',
	);

	function import()
	{
		global $mybb, $output, $import_session, $db;

		$this->board->db_connect();

		// Get number of threads
		if(!isset($import_session['total_forumperms']))
		{
			$query = $this->old_db->simple_select("forumpermission", "COUNT(*) as count");
			$import_session['total_forumperms'] = $this->old_db->fetch_field($query, 'count');
			$this->old_db->free_result($query);
		}
		
		if($this->board->check_if_done())
		{
			return "finished";
		}
		
		$output->print_header($this->board->modules[$import_session['module']]['name']);

		// Get number of threads per screen from form
		if(isset($mybb->input['forumperms_per_screen']))
		{
			$import_session['forumperms_per_screen'] = intval($mybb->input['forumperms_per_screen']);
		}
		
		if(empty($import_session['forumperms_per_screen']))
		{
			$output->print_per_screen_page(1000);
		}
		else
		{
			// A bit of stats to show the progress of the current import
			$output->calculate_stats();
			
			$query = $this->old_db->simple_select("forumpermission", "*", "", array('limit_start' => $import_session['start_forumperms'], 'limit' => $import_session['forumperms_per_screen']));
			while($perm = $this->old_db->fetch_array($query))
			{				
				$this->insert($perm);
			}
			
			if($this->old_db->num_rows($query) == 0)
			{
				$output->print_none_left_message();
			}
		}
		$import_session['start_forumperms'] += $import_session['forumperms_per_screen'];
		$output->print_footer();
	}
	
	function convert_data($data)
	{
		$insert_data = array();
		
		// vBulletin 3 values
		$insert_data['fid'] = $this->get_import->fid($data['forumid']);
		$insert_data['gid'] = $this->board->get_group_id($data['usergroupid'], array("not_multiple" => true));
		
		$perm_bits = array(
			"canview" => 1, 
			"canviewthreads" => 2,
			"candlattachments" => 4096,
			"canpostthreads" => 16,
			"canpostreplys" => 64,
			"canpostattachments" => 8192,
			"canratethreads" => 65536,
			"caneditposts" => 128,
			"candeleteposts" => 256,
			"candeletethreads" => 512,
			"caneditattachments" => 8192,
			"canpostpolls" => 16384,
			"canvotepolls" => 32768,
			"cansearch" => 4
		);
		
		foreach($perm_bits as $key => $val) 
		{
			if($data['forumpermissions'] & $val) 
			{
				$insert_data[$key] = 1; 
			} 
			else 
			{ 
				$insert_data[$key] = 0; 
			}
		}
		
		return $insert_data;
	}
}

?>