<?php
/**
 * MyBB 1.4
 * Copyright © 2009 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybboard.net
  * License: http://www.mybboard.net/about/license
 *
 * $Id$
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

class VBULLETIN3_Converter_Module_Privatemessages extends Converter_Module_Privatemessages {

	var $settings = array(
		'friendly_name' => 'prywatnych wiadomości',
		'progress_column' => 'pmid',
	);

	function import()
	{
		global $mybb, $output, $import_session, $db;

		$this->board->db_connect();

		// Get number of usergroups
		if(!isset($import_session['total_privatemessages']))
		{
			$query = $this->old_db->simple_select("pm", "COUNT(*) as count");
			$import_session['total_privatemessages'] = $this->old_db->fetch_field($query, 'count');
			$this->old_db->free_result($query);
		}

		if($this->board->check_if_done())
		{
			return "finished";
		}

		$output->print_header($this->board->modules[$import_session['module']]['name']);

		// Get number of posts per screen from form
		if(isset($mybb->input['privatemessages_per_screen']))
		{
			$import_session['privatemessages_per_screen'] = intval($mybb->input['privatemessages_per_screen']);
		}
		
		if(empty($import_session['privatemessages_per_screen']))
		{
			$output->print_per_screen_page(1000);
		}
		else
		{
			// A bit of stats to show the progress of the current import
			$output->calculate_stats();
			
			$query = $this->old_db->query("
				SELECT * 
				FROM ".OLD_TABLE_PREFIX."pm p
				LEFT JOIN ".OLD_TABLE_PREFIX."pmtext pt ON(p.pmtextid=pt.pmtextid)
				LIMIT ".$import_session['start_privatemessages'].", ".$import_session['privatemessages_per_screen']
			);			
			while($pm = $this->old_db->fetch_array($query))
			{
				$this->insert($pm);
			}
			
			if($this->old_db->num_rows($query) == 0)
			{
				$output->print_none_left_message();
			}
		}
		$import_session['start_privatemessages'] += $import_session['privatemessages_per_screen'];
		$output->print_footer();
	}
	
	function convert_data($data)
	{
		global $db;
		
		// vBulletin 3 values
		$insert_data['import_pmid'] = $data['pmid'];
		$insert_data['uid'] = $this->get_import->uid($data['userid']);
		$insert_data['fromid'] = $this->get_import->uid($data['fromuserid']);
		$insert_data['toid'] = $this->get_import->uid($data['touserid']);
		$touserarray = unserialize($data['touserarray']);

		// Rebuild the recipients array
		$recipients = array();
		if(is_array($touserarray['cc']) && !empty($touserarray['cc']))
		{
			foreach($touserarray['cc'] as $key => $to)
			{
				$username = $this->get_username($to);					
				$recipients['to'][] = $this->get_import->uid($username['userid']);
			}
		}
		$insert_data['recipients'] = serialize($recipients);
		
		if($data['folderid'] == -1)
		{
			$insert_data['folder'] = 2;
		}
		else
		{
			$insert_data['folder'] = 0;
		}
		
		$insert_data['subject'] = encode_to_utf8($data['subject'], "pm", "privatemessages");
		$insert_data['status'] = $data['messageread'];
		$insert_data['dateline'] = $data['dateline'];
		$insert_data['message'] = encode_to_utf8($this->bbcode_parser->convert($data['message']), "pmtext", "privatemessages");
		$insert_data['includesig'] = $data['showsignature'];
		$insert_data['smilieoff'] = int_to_01($data['allowsmilie']);
		
		if($data['messageread'] == 1)
		{
			$insert_data['readtime'] = time();
		}
		
		return $insert_data;
	}
	
	/**
	 * Get a user from the vB database
	 *
	 * @param int Username
	 * @return array If the username is empty, returns an array of username as Guest.  Otherwise returns the user
	 */
	function get_username($username)
	{
		if(empty($username))
		{
			return array(
				'username' => 'Gość',
				'userid' => 0,
			);
		}
				
		$query = $this->old_db->simple_select("user", "*", "username = '".$this->old_db->escape_string($username)."'", array('limit' => 1));
		
		$results = $this->old_db->fetch_array($query);
		$this->old_db->free_result($query);
		
		return $results;
	}
}

?>