<?php
/**
 * MyBB 1.4
 * Copyright © 2009 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybboard.net
  * License: http://www.mybboard.net/about/license
 *
 * $Id$
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

class VBULLETIN3_Converter_Module_Threads extends Converter_Module_Threads {

	var $settings = array(
		'friendly_name' => 'wątków',
		'progress_column' => 'threadid',
	);

	function import()
	{
		global $mybb, $output, $import_session, $db;

		$this->board->db_connect();

		// Get number of threads
		if(!isset($import_session['total_threads']))
		{
			$query = $this->old_db->simple_select("thread", "COUNT(*) as count");
			$import_session['total_threads'] = $this->old_db->fetch_field($query, 'count');
			$this->old_db->free_result($query);
		}

		if($this->board->check_if_done())
		{
			return "finished";
		}
		
		$output->print_header($this->board->modules[$import_session['module']]['name']);

		// Get number of threads per screen from form
		if(isset($mybb->input['threads_per_screen']))
		{
			$import_session['threads_per_screen'] = intval($mybb->input['threads_per_screen']);
		}
		
		if(empty($import_session['threads_per_screen']))
		{
			$output->print_per_screen_page(1000);
		}
		else
		{
			// A bit of stats to show the progress of the current import
			$output->calculate_stats();
			
			$query = $this->old_db->simple_select("thread", "*", "", array('order_by' => 'firstpostid', 'order_dir' => 'DESC', 'limit_start' => $import_session['start_threads'], 'limit' => $import_session['threads_per_screen']));
			while($thread = $this->old_db->fetch_array($query))
			{
				$this->insert($thread);		
			}
			
			if($this->old_db->num_rows($query) == 0)
			{
				$output->print_none_left_message();
			}
		}
		$import_session['start_threads'] += $import_session['threads_per_screen'];
		$output->print_footer();
	}
	
	function convert_data($data)
	{
		$insert_data = array();
		
		// vBulletin 3 values
		$insert_data['import_tid'] = $data['threadid'];
		$insert_data['sticky'] = $data['sticky'];
		$insert_data['fid'] = $this->get_import->fid($data['forumid']);
		$insert_data['firstpost'] = ((-1) * $data['firstpostid']);
		$insert_data['dateline'] = $data['dateline'];
		$insert_data['subject'] = encode_to_utf8(str_replace('&quot;', '"', $data['title']), "thread", "threads");
		$insert_data['import_poll'] = $data['pollid'];
		$insert_data['uid'] = $this->get_import->uid($data['postuserid']);
		$insert_data['import_uid'] = $data['postuserid'];
		$insert_data['views'] = $data['views'];
		$insert_data['closed'] = int_to_01($data['open']);
						
		if($insert_data['closed'] == 'no')
		{
			$insert_data['closed'] = '';
		}
		
		if($data['open'] == '10')
		{
			$insert_data['closed'] = 'moved|'.$this->get_import->tid($data['pollid']);
		}
		
		$insert_data['totalratings'] = $data['votetotal'];
		$insert_data['notes'] = $data['notes'];
		$insert_data['visible'] = $data['visible'];
		$insert_data['numratings'] = $data['votenum'];
		$insert_data['attachmentcount'] = $data['attach'];
				
		return $insert_data;
	}
}

?>