<?php
/**
 * MyBB 1.4
 * Copyright © 2009 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybboard.net
  * License: http://www.mybboard.net/about/license
 *
 * $Id: xmb.php 2752 2007-02-10 21:22:17Z Tikitiki $
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

class XMB_Converter extends Converter
{

	/**
	 * String of the bulletin board name
	 *
	 * @var string
	 */
	var $bbname = "XMB 1.9";
	
	/**
	 * String of the plain bulletin board name
	 *
	 * @var string
	 */
	var $plain_bbname = "XMB 1.9";
	
	/**
	 * Whether or not this module requires the loginconvert.php plugin
	 *
	 * @var boolean
	 */
	var $requires_loginconvert = false;
	
	/**
	 * Array of all of the modules
	 *
	 * @var array
	 */
	var $modules = array("db_configuration" => array("name" => "Konfiguracja bazy danych", "dependencies" => ""),
						 "import_users" => array("name" => "Użytkownicy", "dependencies" => "db_configuration"),
						 "import_categories" => array("name" => "Kategorie", "dependencies" => "db_configuration,import_users"),
						 "import_forums" => array("name" => "Działy", "dependencies" => "db_configuration,import_categories"),
						 "import_threads" => array("name" => "Wątki", "dependencies" => "db_configuration,import_forums"),
						 "import_polls" => array("name" => "Ankiety", "dependencies" => "db_configuration,import_threads"),
						 "import_pollvotes" => array("name" => "Głosy w ankietach", "dependencies" => "db_configuration,import_polls"),
						 "import_posts" => array("name" => "Posty","dependencies" => "db_configuration,import_threads"),
						 "import_moderators" => array("name" => "Moderatorzy","dependencies" => "db_configuration,import_forums,import_users"),
						 "import_settings" => array("name" => "Ustawienia","dependencies" => "db_configuration"),
						 "import_attachments" => array("name" => "Załączniki", "dependencies" => "db_configuration,import_posts"),
						);
	
	/**
	 * Get a user id from the XMB database
	 *
	 * @param int Username
	 * @return int The user id
	 */
	function get_uid($username)
	{
		if($username == 'Guest' || empty($username))
		{
			return 0;
		}
		
		$query = $this->old_db->simple_select("members", "uid", "username = '".$this->old_db->escape_string($username)."'");
		$results = $this->old_db->fetch_field($query, "uid");
		$this->old_db->free_result($query);
		
		return $results;
	}
}

?>