<?php
/**
 * MyBB 1.4
 * Copyright © 2009 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybboard.net
  * License: http://www.mybboard.net/about/license
 *
 * $Id$
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

class XMB_Converter_Module_Moderators extends Converter_Module_Moderators {

	var $settings = array(
		'friendly_name' => 'moderatorów',
		'progress_column' => 'uid',
	);

	function import()
	{
		global $mybb, $output, $import_session, $db;

		$this->board->db_connect();

		// Get number of moderators
		if(!isset($import_session['total_moderators']))
		{
			$query = $this->old_db->simple_select("forums", "COUNT(*) as count", "type='forum' AND moderator != ''");
			$import_session['total_moderators'] = $this->old_db->fetch_field($query, 'count');
			$this->old_db->free_result($query);
		}
		
		if($this->board->check_if_done())
		{
			return "finished";
		}
		
		$output->print_header($this->board->modules[$import_session['module']]['name']);
		
		// Get number of posts per screen from form
		if(isset($mybb->input['moderators_per_screen']))
		{
			$import_session['moderators_per_screen'] = intval($mybb->input['moderators_per_screen']);
		}
		
		if(empty($import_session['moderators_per_screen']))
		{
			$output->print_per_screen_page(1000);
		}
		else
		{
			// A bit of stats to show the progress of the current import
			$output->calculate_stats();
			
			$query = $this->old_db->simple_select("forums", "fid,moderator", "type='forum' AND moderator != ''", array('limit_start' => $import_session['start_moderators'], 'limit' => $import_session['moderators_per_screen']));
			while($moderator = $this->old_db->fetch_array($query))
			{
				$this->process_moderators($moderator);
			}
			
			if($this->old_db->num_rows($query) == 0)
			{
				$output->print_none_left_message();
			}
		}
		$import_session['start_moderators'] += $import_session['moderators_per_screen'];
		$output->print_footer();
	}
	
	function process_moderators($moderator)
	{
		$insert_moderator = array();
		if(!empty($moderator['moderator']))
		{
			$moderators = @explode(',', $moderator['moderator']);
			foreach($moderators as $key => $username)
			{
				$moderator_data['uid'] = $this->board->get_uid($username);
				$moderator_data['fid'] = $moderator['fid'];
				
				$this->insert($moderator_data);
			}
		}
	}
	
	function convert_data($data)
	{
		$insert_data = array();
		
		// XMB values
		$insert_data['fid'] = $this->get_import->fid_f($data['fid']);
		$insert_data['uid'] = $this->get_import->uid($data['uid']);
		
		return $insert_data;
	}
}

?>