<?php
/**
 * MyBB 1.4
 * Copyright © 2009 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybboard.net
  * License: http://www.mybboard.net/about/license
 *
 * $Id$
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

class XMB_Converter_Module_Posts extends Converter_Module_Posts {

	var $settings = array(
		'friendly_name' => 'postów',
		'progress_column' => 'pid',
	);

	function import()
	{
		global $mybb, $output, $import_session, $db;

		$this->board->db_connect();

		// Get number of posts
		if(!isset($import_session['total_posts']))
		{
			$query = $this->old_db->simple_select("posts", "COUNT(*) as count");
			$import_session['total_posts'] = $this->old_db->fetch_field($query, 'count');
			$this->old_db->free_result($query);
		}
		
		if($this->board->check_if_done())
		{
			return "finished";
		}
		
		$output->print_header($this->board->modules[$import_session['module']]['name']);
		
		// Get number of posts per screen from form
		if(isset($mybb->input['posts_per_screen']))
		{
			$import_session['posts_per_screen'] = intval($mybb->input['posts_per_screen']);
		}
		
		if(empty($import_session['posts_per_screen']))
		{
			$this->check_table_type("posts");
			$output->print_per_screen_page(1000);
		}
		else
		{	
			// A bit of stats to show the progress of the current import
			$output->calculate_stats();

			$query = $this->old_db->simple_select("posts", "*", "", array('limit_start' => $import_session['start_posts'], 'limit' => $import_session['posts_per_screen']));
			while($post = $this->old_db->fetch_array($query))
			{
				$pid = $this->insert($post);
				
				// Restore connection
				$db->update_query("threads", array('firstpost' => $pid), "firstpost='".((-1) * $post['pid'])."'");			
			}
			
			if($this->old_db->num_rows($query) == 0)
			{
				$output->print_none_left_message();
			}
		}
		$import_session['start_posts'] += $import_session['posts_per_screen'];
		$output->print_footer();
	}
	
	function convert_data($data)
	{
		global $db;
		
		$insert_data = array();
		
		// XMB values
		$insert_data['import_pid'] = $data['pid'];
		$insert_data['tid'] = $this->get_import->tid($data['tid']);
		
		// Find if this is the first post in thread
		$query = $db->simple_select("threads", "firstpost", "tid='{$insert_data['tid']}'");
		$first_post = $db->fetch_field($query, "firstpost");
		$db->free_result($query);
		
		// Make the replyto the first post of thread unless it is the first post
		if($first_post == $data['pid'])
		{
			$insert_data['replyto'] = 0;
		}
		else
		{
			$insert_data['replyto'] = $first_post;
		}
		
		// Check usernames for guests
		if($data['author'] == 'Anonymous')
		{
			$data['author'] = 'Guest';
		}
		
		$insert_data['fid'] = $this->get_import->fid_f($data['fid']);
		$insert_data['subject'] = encode_to_utf8(stripslashes($data['subject']), "posts", "posts");
		$insert_data['import_uid'] = $this->board->get_uid($data['author']);
		$insert_data['uid'] = $this->get_import->uid($insert_data['import_uid']);
		$insert_data['username'] = stripslashes($data['author']);
		$insert_data['dateline'] = $data['dateline'];
		$insert_data['message'] = encode_to_utf8(stripslashes($data['message']), "posts", "posts");
		$insert_data['ipaddress'] = $data['useip'];
		$insert_data['includesig'] = yesno_to_int($data['usesig']);
		$insert_data['smilieoff'] = $data['smileyoff'];
		
		return $insert_data;
	}
}

?>