<?php
/**
 * MyBB 1.4
 * Copyright ę 2009 MyBB Group, All Rights Reserved
 *
 * Website: http://www.mybboard.net
  * License: http://www.mybboard.net/about/license
 *
 * $Id$
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

class XMB_Converter_Module_Settings extends Converter_Module_Settings {

	var $settings = array(
		'friendly_name' => 'ustawień',
	);

	function import()
	{
		global $mybb, $output, $import_session, $db;

		$this->board->db_connect();
		
		// What settings do we need to get and what is their MyBB equivalent?
		$settings_array = array(
			"postperpage" => "postsperpage",
			"topicperpage" => "threadsperpage",
			"hottopic" => "hottopic",
			"bbstatus" => "boardclosed",
			"regstatus" => "disableregs",
			"bboffreason" => "boardclosed_reason",
			"floodctrl" => "postfloodsecs",
			"memberperpage" => "membersperpage",
			"hideprivate" => "hideprivateforums",
			"emailcheck" => "regtype",
			"sigbbcode" => "sigmycode",
			"sightml" => "sightml",
			"whosonlinestatus" => "showwol",
			"smtotal" => "smilieinsertertot",
			"smcols" => "smilieinsertercols",
			"dotfolders" => "dotfolders",
			"attachimgpost" => "attachthumbnails",
			"max_avatar_size" => "maxavatardims",
			"def_tz" => "timezoneoffset",
			"maxattachsize" => "avatarresizing",
		);
		$settings = "'".implode("','", array_keys($settings_array))."'";
		$on_off_to_yes_no = array(
			"bbstatus",
			"regstatus",
			"hideprivate",
			"whosonlinestatus",
			"attachimgpost",			
		);
		
		// Get number of settings
		if(!isset($import_session['total_settings']))
		{
			$field_info = $this->old_db->show_fields_from("settings");
			foreach($field_info as $key => $field)
			{
				if(array_key_exists($field['Field'], $settings_array))
				{
					$query2 = $this->old_db->simple_select("settings", $field['Field'], "", array('limit' => 1));
					$setting_list[$field['Field']] = $this->old_db->fetch_field($query2, $field['Field']);
					$this->old_db->free_result($query2);
				}
			}
			$import_session['setting_list'] = $setting_list;
			$import_session['total_settings'] = count($setting_list);
		}
		
		if($this->board->check_if_done())
		{
			rebuild_settings();
			return "finished";
		}
		
		$output->print_header($this->board->modules[$import_session['module']]['name']);
		
		// Get number of settings per screen from form
		if(isset($mybb->input['settings_per_screen']))
		{
			$import_session['settings_per_screen'] = intval($mybb->input['settings_per_screen']);
		}
		
		if(empty($import_session['settings_per_screen']))
		{
			$output->print_per_screen_page(1000);
		}
		else
		{
			// A bit of stats to show the progress of the current import
			$output->calculate_stats();
			
			$done_settings = $import_session['settings_per_screen'];
			
			foreach($settings_array as $oldname => $name)
			{
				// XMB values
				$value = $import_session['setting_list'][$oldname];
				
				if(array_key_exists($oldname, $on_off_to_yes_no))
				{
					if($value == "on")
					{
						$value = 0;
					}
					else
					{
						$value = 1;
					}
				}
				
				if($oldname == "emailcheck" && $value == "on")
				{
					$value = "randompass";
				}
				
				if($oldname == "def_tz")
				{
					$value = intval($value);
				}
				
				$this->update_setting($name, $value);
				
				--$done_settings;
				unset($import_session['setting_list'][$oldname]);
				
				if($done_settings == 0)
				{
					break;
				}
			}
			
			if($import_session['total_settings'] == 0)
			{
				$output->print_none_left_message();
			}
		}
		$import_session['start_settings'] += $import_session['settings_per_screen'];
		$output->print_footer();
	}
}

?>