<?php

class Converter_Module_Events extends Converter_Module
{
	public $default_values = array(
		'import_eid' => 0,
		'cid' => 0,
		'uid' => 0,
		'name' => '',
		'description' => '',
		'visible' => 0,
		'private' => 0,
		'dateline' => 0,
		'starttime' => 0,
		'endtime' => 0,
		'timezone' => 0,
		'ignoretimezone' => 0,
		'usingtime' => 0,
		'repeats' => ''
	);
	
	/**
	 * Insert an event into database
	 *
	 * @param event The insert array going into the MyBB database
	 */
	public function insert($data)
	{
		global $db, $output;
		
		$output->print_progress("start", $data[$this->settings['progress_column']]);
		
		if(WRITE_LOGS == 1)
		{
			$old_data = $data;
		}
		
		// Call our currently module's process function
		$data = $this->convert_data($data);
		
		// Should loop through and fill in any values that aren't set based on the MyBB db schema or other standard default values
		$data = $this->process_default_values($data);

		foreach($data as $key => $value)
		{
			$insert_array[$key] = $db->escape_string($value);
		}
		
		if(WRITE_LOGS == 1)
		{
			global $import_session;
			
			$debug_log = @fopen(MYBB_ROOT."convert/logs/event_debug_data_140_{$import_session['start_date']}.log", 'ab');
			if($debug_log)
			{
				fwrite($debug_log, var_export($insert_array, true));
				@fclose($debug_log);
			}
			
			$debug_log = @fopen(MYBB_ROOT."convert/logs/event_debug_data_oldbb_140_{$import_session['start_date']}.log", 'ab');
			if($debug_log)
			{
				fwrite($debug_log, var_export($old_data, true));
				@fclose($debug_log);
			}
		}

		$db->insert_query("events", $insert_array);
		$eid = $db->insert_id();
		
		$output->print_progress("end");

		return $eid;
	}
}

?>