<?php

class Converter_Module_Forumperms extends Converter_Module
{
	public $default_values = array(
		'gid' => 0,
		'canview' => 1,
		'canviewthreads' => 1,
		'candlattachments' => 1,
		'canpostthreads' => 1,
		'canpostreplys' => 1,
		'canpostattachments' => 1,
		'canratethreads' => 1,
		'caneditposts' => 1,
		'candeleteposts' => 1,
		'candeletethreads' => 1,
		'caneditattachments' => 1,
		'canpostpolls' => 1,
		'canvotepolls' => 1,
		'cansearch' => 1
	);
		
	/**
	 * Insert forumpermissions into database
	 *
	 * @param perm The insert array going into the MyBB database
	 */
	public function insert($data)
	{
		global $db, $output;
		
		if(WRITE_LOGS == 1)
		{
			$old_data = $data;
		}
		
		$output->print_progress("start", $data[$this->settings['progress_column']]);
		
		// Call our currently module's process function
		$data = $this->convert_data($data);
		
		// Should loop through and fill in any values that aren't set based on the MyBB db schema or other standard default values
		$data = $this->process_default_values($data);

		foreach($data as $key => $value)
		{
			$insert_array[$key] = $db->escape_string($value);
		}
		
		if(WRITE_LOGS == 1)
		{
			global $import_session;
			
			$debug_log = @fopen(MYBB_ROOT."convert/logs/forumpermission_debug_data_140_{$import_session['start_date']}.log", 'ab');
			if($debug_log)
			{
				fwrite($debug_log, var_export($insert_array, true));
				@fclose($debug_log);
			}
			
			$debug_log = @fopen(MYBB_ROOT."convert/logs/forumpermission_debug_data_oldbb_140_{$import_session['start_date']}.log", 'ab');
			if($debug_log)
			{
				fwrite($debug_log, var_export($old_data, true));
				@fclose($debug_log);
			}
		}
		
		$query = $db->insert_query("forumpermissions", $insert_array);
		$fpid = $db->insert_id();
		
		$output->print_progress("end");
		
		return $fpid;
	}
}

?>