<?php

class Converter_Module_Polls extends Converter_Module
{
	public $default_values = array(
		'import_pid' => 0,
		'tid' => 0,
		'question' => '',
		'dateline' => 0,
		'options' => '',
		'votes' => '',
		'numoptions' => 2,
		'numvotes' => 0,
		'timeout' => 0,
		'closed' => 0,
		'multiple' => 0,
		'public' => 0
	);
	
	/**
	 * Insert poll into database
	 *
	 * @param poll The insert array going into the MyBB database
	 */
	public function insert($data)
	{
		global $db, $output;
		
		if(WRITE_LOGS == 1)
		{
			$old_data = $data;
		}
		
		$output->print_progress("start", $data[$this->settings['progress_column']]);
		
		// Call our currently module's process function
		$data = $this->convert_data($data);
		
		// Should loop through and fill in any values that aren't set based on the MyBB db schema or other standard default values
		$data = $this->process_default_values($data);

		foreach($data as $key => $value)
		{
			$insert_array[$key] = $db->escape_string($value);
		}
		
		if(WRITE_LOGS == 1)
		{
			global $import_session;
			
			$debug_log = @fopen(MYBB_ROOT."convert/logs/poll_debug_data_140_{$import_session['start_date']}.log", 'ab');
			if($debug_log)
			{
				fwrite($debug_log, var_export($insert_array, true));
				@fclose($debug_log);
			}
			
			$debug_log = @fopen(MYBB_ROOT."convert/logs/poll_debug_data_oldbb_140_{$import_session['start_date']}.log", 'ab');
			if($debug_log)
			{
				fwrite($debug_log, var_export($old_data, true));
				@fclose($debug_log);
			}
		}
		
		$db->insert_query("polls", $insert_array);
		$pollid = $db->insert_id();
		
		$output->print_progress("end");
		
		return $pollid;
	}
}

?>