<?php

class Converter_Module_Threads extends Converter_Module
{
	public $default_values = array(
		'import_tid' => 0,
		'sticky' => 0,
		'fid' => 0,
		'firstpost' => 0,
		'dateline' => 0,
		'subject' => '',
		'poll' => 0,
		'uid' => 0,
		'import_uid' => 0,
		'views' => 0,
		'closed' => 0,
		'totalratings' => 0,
		'notes' => '',
		'visible' => 1,
		'unapprovedposts' => 0,
		'numratings' => 0,
		'attachmentcount' => 0,
		'username' => '',
		'lastpost' => 0,
		'lastposter' => '',
		'lastposteruid' => 0,
		'replies' => 0,
		'icon' => 0,
		'deletetime' => 0,
	);
	
	/**
	 * Insert thread into database
	 *
	 * @param thread The insert array going into the MyBB database
	 */
	public function insert($data)
	{
		global $db, $output;
		
		if(WRITE_LOGS == 1)
		{
			$old_data = $data;
		}
		
		$output->print_progress("start", $data[$this->settings['progress_column']]);
		
		// Call our currently module's process function
		$data = $this->convert_data($data);
		
		// Should loop through and fill in any values that aren't set based on the MyBB db schema or other standard default values
		$data = $this->process_default_values($data);

		foreach($data as $key => $value)
		{
			$insert_array[$key] = $db->escape_string($value);
		}
		
		if(WRITE_LOGS == 1)
		{
			global $import_session;
			
			$debug_log = @fopen(MYBB_ROOT."convert/logs/thread_debug_data_140_{$import_session['start_date']}.log", 'ab');
			if($debug_log)
			{
				fwrite($debug_log, var_export($insert_array, true));
				@fclose($debug_log);
			}
			
			$debug_log = @fopen(MYBB_ROOT."convert/logs/thread_debug_data_oldbb_140_{$import_session['start_date']}.log", 'ab');
			if($debug_log)
			{
				fwrite($debug_log, var_export($old_data, true));
				@fclose($debug_log);
			}
		}
		
		$db->insert_query("threads", $insert_array);
		$tid = $db->insert_id();
		
		$this->cache_tids[$data['import_tid']] = $tid;
		
		$output->print_progress("end");
		
		return $tid;
	}
}

?>