<?php

class Converter_Module_Usergroups extends Converter_Module
{
	public $default_values = array(
		'import_gid' => 0,
		'title' => '',
		'canview' => 1,
		'canpostthreads' => 1,
		'canpostreplys' => 1,
		'caneditposts' => 1,
		'candeleteposts' => 1,
		'candeletethreads' => 1,
		'cansearch' => 1,
		'canviewmemberlist' => 1,
		'caneditattachments' => 1,
		'canpostpolls' => 1,
		'canvotepolls' => 1,
		'canpostattachments' => 1,
		'canratethreads' => 1,
		'canviewthreads' => 1,
		'canviewprofiles' => 1,
		'candlattachments' => 1,
		'description' => '',
		'namestyle' => '{username}',
		'type' => 2,
		'stars' => 0,
		'starimage' => 'images/star.gif',
		'image' => '',
		'disporder' => 0,
		'isbannedgroup' => 0,
		'canusepms' => 1,
		'cansendpms' => 1,
		'cantrackpms' => 1,
		'candenypmreceipts' => 1,
		'pmquota' => 0,
		'maxpmrecipients' => 5,
		'cansendemail' => 1,
		'canviewcalendar' => 1,
		'canaddevents' => 1,
		'canviewonline' => 1,
		'canviewwolinvis' => 0,
		'canviewonlineips' => 0,
		'cancp' => 0,
		'issupermod' => 0,
		'canusercp' => 1,
		'canuploadavatars' => 1,
		'canratemembers' => 1,
		'canchangename' => 0,
		'showforumteam' => 0,
		'usereputationsystem' => 1,
		'cangivereputations' => 1,
		'reputationpower' => 1,
		'maxreputationsday' => 5,
		'candisplaygroup' => 1,
		'attachquota' => 0,
		'cancustomtitle' => 1,
	);
	
	/**
	 * Insert usergroup into database
	 *
	 * @param group The insert array going into the MyBB database
	 */
	public function insert($data)
	{
		global $db, $output;
		
		if(WRITE_LOGS == 1)
		{
			$old_data = $data;
		}
		
		$output->print_progress("start", $data[$this->settings['progress_column']]);
		
		// Call our currently module's process function
		$data = $this->convert_data($data);
		
		// Should loop through and fill in any values that aren't set based on the MyBB db schema or other standard default values
		$data = $this->process_default_values($data);
		
		foreach($data as $key => $value)
		{
			$insert_array[$key] = $db->escape_string($value);
		}
		
		if(WRITE_LOGS == 1)
		{
			global $import_session;
			
			$debug_log = @fopen(MYBB_ROOT."convert/logs/usergroup_debug_data_140_{$import_session['start_date']}.log", 'ab');
			if($debug_log)
			{
				fwrite($debug_log, var_export($insert_array, true));
				@fclose($debug_log);
			}
			
			$debug_log = @fopen(MYBB_ROOT."convert/logs/usergroup_debug_data_oldbb_140_{$import_session['start_date']}.log", 'ab');
			if($debug_log)
			{
				fwrite($debug_log, var_export($old_data, true));
				@fclose($debug_log);
			}
		}
		
		$db->insert_query("usergroups", $insert_array);
		$gid = $db->insert_id();
		
		// Update internal array cache
		$this->cache_gids[$group['import_gid']] = $gid; // TODO: Fix?
		
		$output->print_progress("end");
		
		return $gid;
	}
}

?>